diff --git a/src/mongo/db/matcher/expression_tree.cpp b/src/mongo/db/matcher/expression_tree.cpp
index 9c3d79c073..a23b4f9f8d 100644
--- a/src/mongo/db/matcher/expression_tree.cpp
+++ b/src/mongo/db/matcher/expression_tree.cpp
@@ -193,20 +193,30 @@ bool ListOfMatchExpression::equivalent(const MatchExpression* other) const {
 
 // -----
 
-bool AndMatchExpression::matches(const MatchableDocument* doc, MatchDetails* details) const {
+bool AndMatchExpression::matches(const MatchableDocument* doc,
+                                 ArrayPositionalMatch* details,
+                                 std::deque<std::string>* explain) const {
     for (size_t i = 0; i < numChildren(); i++) {
-        if (!getChild(i)->matches(doc, details)) {
+        if (!getChild(i)->matches(doc, details, explain)) {
             if (details)
-                details->resetOutput();
+                details->reset();
+            if (explain) {
+                explain->push_front(str::stream() << "clause " << i << " of $and failed: ");
+            }
             return false;
         }
     }
     return true;
 }
 
-bool AndMatchExpression::matchesSingleElement(const BSONElement& e, MatchDetails* details) const {
+bool AndMatchExpression::matchesSingleElement(const BSONElement& e,
+                                              ArrayPositionalMatch* details,
+                                              std::deque<std::string>* explain) const {
     for (size_t i = 0; i < numChildren(); i++) {
-        if (!getChild(i)->matchesSingleElement(e, details)) {
+        if (!getChild(i)->matchesSingleElement(e, details, explain)) {
+            if (explain) {
+                explain->push_front(str::stream() << "clause " << i << " of $and failed: ");
+            }
             return false;
         }
     }
@@ -238,18 +248,32 @@ bool AndMatchExpression::isTriviallyTrue() const {
 
 // -----
 
-bool OrMatchExpression::matches(const MatchableDocument* doc, MatchDetails* details) const {
+bool OrMatchExpression::matches(const MatchableDocument* doc,
+                                ArrayPositionalMatch*,
+                                std::deque<std::string>* explain) const {
     for (size_t i = 0; i < numChildren(); i++) {
-        if (getChild(i)->matches(doc, NULL)) {
+        // We purposefully do not set the ArrayPositionalMatch. Users can use the array filters
+        // feature to find the array position of a non-matching element.
+        constexpr auto positionalMatch = nullptr;
+        if (getChild(i)->matches(doc, positionalMatch, explain)) {
+            if (explain) {
+                explain->clear();
+            }
             return true;
         }
     }
+
+    if (explain) {
+        explain->push_front("no clauses of $or were satisfied: ");
+    }
     return false;
 }
 
-bool OrMatchExpression::matchesSingleElement(const BSONElement& e, MatchDetails* details) const {
+bool OrMatchExpression::matchesSingleElement(const BSONElement& e,
+                                             ArrayPositionalMatch* details,
+                                             std::deque<std::string>* explain) const {
     for (size_t i = 0; i < numChildren(); i++) {
-        if (getChild(i)->matchesSingleElement(e, details)) {
+        if (getChild(i)->matchesSingleElement(e, details, explain)) {
             return true;
         }
     }
@@ -281,18 +305,25 @@ bool OrMatchExpression::isTriviallyFalse() const {
 
 // ----
 
-bool NorMatchExpression::matches(const MatchableDocument* doc, MatchDetails* details) const {
+bool NorMatchExpression::matches(const MatchableDocument* doc,
+                                 ArrayPositionalMatch* details,
+                                 std::deque<std::string>* explain) const {
     for (size_t i = 0; i < numChildren(); i++) {
-        if (getChild(i)->matches(doc, NULL)) {
+        // We purposefully do not set the ArrayPositionalMatch for negative match expressions. Users
+        // can use the array filters feature to find the array position of a non-matching element.
+        constexpr auto positionalMatch = nullptr;
+        if (getChild(i)->matches(doc, positionalMatch, explain)) {
             return false;
         }
     }
     return true;
 }
 
-bool NorMatchExpression::matchesSingleElement(const BSONElement& e, MatchDetails* details) const {
+bool NorMatchExpression::matchesSingleElement(const BSONElement& e,
+                                              ArrayPositionalMatch* details,
+                                              std::deque<std::string>* explain) const {
     for (size_t i = 0; i < numChildren(); i++) {
-        if (getChild(i)->matchesSingleElement(e, details)) {
+        if (getChild(i)->matchesSingleElement(e, details, explain)) {
             return false;
         }
     }
diff --git a/src/mongo/db/matcher/expression_tree.h b/src/mongo/db/matcher/expression_tree.h
index d92a9118e7..708c48050e 100644
--- a/src/mongo/db/matcher/expression_tree.h
+++ b/src/mongo/db/matcher/expression_tree.h
@@ -111,9 +111,13 @@ public:
     AndMatchExpression() : ListOfMatchExpression(AND) {}
     virtual ~AndMatchExpression() {}
 
-    virtual bool matches(const MatchableDocument* doc, MatchDetails* details = 0) const;
+    virtual bool matches(const MatchableDocument* doc,
+                         ArrayPositionalMatch* = nullptr,
+                         std::deque<std::string>* = nullptr) const;
 
-    bool matchesSingleElement(const BSONElement&, MatchDetails* details = nullptr) const final;
+    bool matchesSingleElement(const BSONElement&,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final;
 
     virtual std::unique_ptr<MatchExpression> shallowClone() const {
         std::unique_ptr<AndMatchExpression> self = stdx::make_unique<AndMatchExpression>();
@@ -140,9 +144,13 @@ public:
     OrMatchExpression() : ListOfMatchExpression(OR) {}
     virtual ~OrMatchExpression() {}
 
-    virtual bool matches(const MatchableDocument* doc, MatchDetails* details = 0) const;
+    virtual bool matches(const MatchableDocument* doc,
+                         ArrayPositionalMatch* = nullptr,
+                         std::deque<std::string>* = nullptr) const;
 
-    bool matchesSingleElement(const BSONElement&, MatchDetails* details = nullptr) const final;
+    bool matchesSingleElement(const BSONElement&,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final;
 
     virtual std::unique_ptr<MatchExpression> shallowClone() const {
         std::unique_ptr<OrMatchExpression> self = stdx::make_unique<OrMatchExpression>();
@@ -169,9 +177,13 @@ public:
     NorMatchExpression() : ListOfMatchExpression(NOR) {}
     virtual ~NorMatchExpression() {}
 
-    virtual bool matches(const MatchableDocument* doc, MatchDetails* details = 0) const;
+    virtual bool matches(const MatchableDocument* doc,
+                         ArrayPositionalMatch* = nullptr,
+                         std::deque<std::string>* = nullptr) const;
 
-    bool matchesSingleElement(const BSONElement&, MatchDetails* details = nullptr) const final;
+    bool matchesSingleElement(const BSONElement&,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final;
 
     virtual std::unique_ptr<MatchExpression> shallowClone() const {
         std::unique_ptr<NorMatchExpression> self = stdx::make_unique<NorMatchExpression>();
@@ -202,12 +214,27 @@ public:
         return std::move(self);
     }
 
-    virtual bool matches(const MatchableDocument* doc, MatchDetails* details = 0) const {
-        return !_exp->matches(doc, NULL);
+    virtual bool matches(const MatchableDocument* doc,
+                         ArrayPositionalMatch* = nullptr,
+                         std::deque<std::string>* explain = nullptr) const {
+        // We purposefully do not set the ArrayPositionalMatch for negative match expressions. Users
+        // can use the array filters feature to find the array position of a non-matching element.
+        constexpr auto positionalMatch = nullptr;
+        bool res = !_exp->matches(doc, positionalMatch, explain);
+        if (!res && explain) {
+            explain->push_front(str::stream() << "subclause evaluated true: " << _exp->toString());
+        }
+        return res;
     }
 
-    bool matchesSingleElement(const BSONElement& elt, MatchDetails* details = nullptr) const final {
-        return !_exp->matchesSingleElement(elt, details);
+    bool matchesSingleElement(const BSONElement& elt,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final {
+        bool res = !_exp->matchesSingleElement(elt, details, explain);
+        if (!res && explain) {
+            explain->push_front(str::stream() << "subclause evaluated true: " << _exp->toString());
+        }
+        return res;
     }
 
     virtual void debugString(StringBuilder& debug, int level = 0) const;
diff --git a/src/mongo/db/matcher/expression_tree_test.cpp b/src/mongo/db/matcher/expression_tree_test.cpp
index 54e85206d7..a575cb0a2e 100644
--- a/src/mongo/db/matcher/expression_tree_test.cpp
+++ b/src/mongo/db/matcher/expression_tree_test.cpp
@@ -63,15 +63,15 @@ TEST(NotMatchExpression, ElemMatchKey) {
     BSONObj baseOperand = BSON("$lt" << 5);
     unique_ptr<ComparisonMatchExpression> lt(new LTMatchExpression("a", baseOperand["$lt"]));
     NotMatchExpression notOp(lt.release());
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!notOp.matchesBSON(BSON("a" << BSON_ARRAY(1)), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(notOp.matchesBSON(BSON("a" << 6), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(notOp.matchesBSON(BSON("a" << BSON_ARRAY(6)), &details));
-    // elemMatchKey is not implemented for negative match operators.
-    ASSERT(!details.hasElemMatchKey());
+    // arrayPosition is not implemented for negative match operators.
+    ASSERT(!details.arrayPosition());
 }
 
 TEST(NotMatchExpression, SetCollatorPropagatesToChild) {
@@ -166,16 +166,16 @@ TEST(AndOp, ElemMatchKey) {
     andOp.add(sub1.release());
     andOp.add(sub2.release());
 
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!andOp.matchesBSON(BSON("a" << BSON_ARRAY(1)), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(!andOp.matchesBSON(BSON("b" << BSON_ARRAY(2)), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(andOp.matchesBSON(BSON("a" << BSON_ARRAY(1) << "b" << BSON_ARRAY(1 << 2)), &details));
-    ASSERT(details.hasElemMatchKey());
+    ASSERT(details.arrayPosition());
     // The elem match key for the second $and clause is recorded.
-    ASSERT_EQUALS("1", details.elemMatchKey());
+    ASSERT_EQUALS("1", *details.arrayPosition());
 }
 
 TEST(OrOp, NoClauses) {
@@ -229,15 +229,15 @@ TEST(OrOp, ElemMatchKey) {
     orOp.add(sub1.release());
     orOp.add(sub2.release());
 
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!orOp.matchesBSON(BSONObj(), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(!orOp.matchesBSON(BSON("a" << BSON_ARRAY(10) << "b" << BSON_ARRAY(10)), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(orOp.matchesBSON(BSON("a" << BSON_ARRAY(1) << "b" << BSON_ARRAY(1 << 2)), &details));
     // The elem match key feature is not implemented for $or.
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
 }
 
 TEST(NorOp, NoClauses) {
@@ -292,15 +292,15 @@ TEST(NorOp, ElemMatchKey) {
     norOp.add(sub1.release());
     norOp.add(sub2.release());
 
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!norOp.matchesBSON(BSON("a" << 1), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(!norOp.matchesBSON(BSON("a" << BSON_ARRAY(1) << "b" << BSON_ARRAY(10)), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(norOp.matchesBSON(BSON("a" << BSON_ARRAY(3) << "b" << BSON_ARRAY(4)), &details));
     // The elem match key feature is not implemented for $nor.
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
 }
 
 
diff --git a/src/mongo/db/matcher/expression_type.h b/src/mongo/db/matcher/expression_type.h
index d38ce36514..9dd99d5a59 100644
--- a/src/mongo/db/matcher/expression_type.h
+++ b/src/mongo/db/matcher/expression_type.h
@@ -60,8 +60,21 @@ public:
     }
 
     bool matchesSingleElement(const BSONElement& elem,
-                              MatchDetails* details = nullptr) const final {
-        return _typeSet.hasType(elem.type());
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final {
+        bool match = _typeSet.hasType(elem.type());
+        if (!match && explain) {
+            StringBuilder builder;
+            builder << "[";
+            for (auto&& type : _typeSet.bsonTypes) {
+                builder << typeName(type) << ", ";
+            }
+            builder << "]";
+            explain->push_front(str::stream() << "element of type " << elem.type()
+                                              << " does not match $type "
+                                              << builder.str());
+        }
+        return match;
     }
 
     void debugString(StringBuilder& debug, int level) const final {
diff --git a/src/mongo/db/matcher/expression_type_test.cpp b/src/mongo/db/matcher/expression_type_test.cpp
index e50f30b9b4..fea848ca73 100644
--- a/src/mongo/db/matcher/expression_type_test.cpp
+++ b/src/mongo/db/matcher/expression_type_test.cpp
@@ -136,21 +136,21 @@ TEST(ExpressionTypeTest, MatchesNull) {
 
 TEST(ExpressionTypeTest, ElemMatchKey) {
     TypeMatchExpression type("a.b", String);
-    MatchDetails details;
-    details.requestElemMatchKey();
+    ArrayPositionalMatch details;
+    details.requestArrayPosition();
     ASSERT(!type.matchesBSON(BSON("a" << 1), &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(type.matchesBSON(BSON("a" << BSON("b"
                                              << "string")),
                             &details));
-    ASSERT(!details.hasElemMatchKey());
+    ASSERT(!details.arrayPosition());
     ASSERT(type.matchesBSON(BSON("a" << BSON("b" << BSON_ARRAY("string"))), &details));
-    ASSERT(details.hasElemMatchKey());
-    ASSERT_EQUALS("0", details.elemMatchKey());
+    ASSERT(details.arrayPosition());
+    ASSERT_EQUALS("0", *details.arrayPosition());
     ASSERT(type.matchesBSON(BSON("a" << BSON_ARRAY(2 << BSON("b" << BSON_ARRAY("string")))),
                             &details));
-    ASSERT(details.hasElemMatchKey());
-    ASSERT_EQUALS("1", details.elemMatchKey());
+    ASSERT(details.arrayPosition());
+    ASSERT_EQUALS("1", *details.arrayPosition());
 }
 
 TEST(ExpressionTypeTest, Equivalent) {
diff --git a/src/mongo/db/matcher/expression_where.cpp b/src/mongo/db/matcher/expression_where.cpp
index dea7756f92..f360c04e15 100644
--- a/src/mongo/db/matcher/expression_where.cpp
+++ b/src/mongo/db/matcher/expression_where.cpp
@@ -70,7 +70,9 @@ WhereMatchExpression::WhereMatchExpression(OperationContext* opCtx,
     uassert(ErrorCodes::BadValue, "$where compile error", _func);
 }
 
-bool WhereMatchExpression::matches(const MatchableDocument* doc, MatchDetails* details) const {
+bool WhereMatchExpression::matches(const MatchableDocument* doc,
+                                   ArrayPositionalMatch* details,
+                                   std::deque<std::string>* explain) const {
     uassert(28692, "$where compile error", _func);
     BSONObj obj = doc->toBSON();
 
diff --git a/src/mongo/db/matcher/expression_where.h b/src/mongo/db/matcher/expression_where.h
index 50062d6583..0f5b66a4f8 100644
--- a/src/mongo/db/matcher/expression_where.h
+++ b/src/mongo/db/matcher/expression_where.h
@@ -39,7 +39,9 @@ class WhereMatchExpression final : public WhereMatchExpressionBase {
 public:
     WhereMatchExpression(OperationContext* opCtx, WhereParams params, StringData dbName);
 
-    bool matches(const MatchableDocument* doc, MatchDetails* details = nullptr) const final;
+    bool matches(const MatchableDocument* doc,
+                 ArrayPositionalMatch* details = nullptr,
+                 std::deque<std::string>* explain = nullptr) const final;
 
     std::unique_ptr<MatchExpression> shallowClone() const final;
 
diff --git a/src/mongo/db/matcher/expression_where_base.h b/src/mongo/db/matcher/expression_where_base.h
index 12e7fd8632..adb6afc0b7 100644
--- a/src/mongo/db/matcher/expression_where_base.h
+++ b/src/mongo/db/matcher/expression_where_base.h
@@ -56,7 +56,9 @@ public:
         return nullptr;
     }
 
-    bool matchesSingleElement(const BSONElement& e, MatchDetails* details = nullptr) const final {
+    bool matchesSingleElement(const BSONElement& e,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final {
         return false;
     }
 
diff --git a/src/mongo/db/matcher/expression_where_noop.cpp b/src/mongo/db/matcher/expression_where_noop.cpp
index c65bf70019..592bc42cb4 100644
--- a/src/mongo/db/matcher/expression_where_noop.cpp
+++ b/src/mongo/db/matcher/expression_where_noop.cpp
@@ -39,7 +39,9 @@ namespace mongo {
 WhereNoOpMatchExpression::WhereNoOpMatchExpression(WhereParams params)
     : WhereMatchExpressionBase(std::move(params)) {}
 
-bool WhereNoOpMatchExpression::matches(const MatchableDocument* doc, MatchDetails* details) const {
+bool WhereNoOpMatchExpression::matches(const MatchableDocument* doc,
+                                       ArrayPositionalMatch* details,
+                                       std::deque<std::string>* explain) const {
     MONGO_UNREACHABLE;
 }
 
diff --git a/src/mongo/db/matcher/expression_where_noop.h b/src/mongo/db/matcher/expression_where_noop.h
index 0ee8a835c0..b0eda8ff0e 100644
--- a/src/mongo/db/matcher/expression_where_noop.h
+++ b/src/mongo/db/matcher/expression_where_noop.h
@@ -42,7 +42,9 @@ class WhereNoOpMatchExpression final : public WhereMatchExpressionBase {
 public:
     explicit WhereNoOpMatchExpression(WhereParams params);
 
-    bool matches(const MatchableDocument* doc, MatchDetails* details = nullptr) const final;
+    bool matches(const MatchableDocument* doc,
+                 ArrayPositionalMatch* details = nullptr,
+                 std::deque<std::string>* explain = nullptr) const final;
 
     std::unique_ptr<MatchExpression> shallowClone() const final;
 };
diff --git a/src/mongo/db/matcher/expression_with_placeholder.h b/src/mongo/db/matcher/expression_with_placeholder.h
index 6bea7cc2a8..9dabe22b28 100644
--- a/src/mongo/db/matcher/expression_with_placeholder.h
+++ b/src/mongo/db/matcher/expression_with_placeholder.h
@@ -72,7 +72,9 @@ public:
      * field whose name is given by getPlaceholder(). If the placeholder name does not exist, then
      * the filter expression does not refer to any specific paths.
      */
-    bool matchesBSONElement(BSONElement elem, MatchDetails* details = nullptr) const {
+    bool matchesBSONElement(BSONElement elem,
+                            ArrayPositionalMatch* details = nullptr,
+                            std::deque<std::string>* explain = nullptr) const {
         return _filter->matchesBSONElement(elem, details);
     }
 
diff --git a/src/mongo/db/matcher/matcher.cpp b/src/mongo/db/matcher/matcher.cpp
index bea280d4d0..1a668a61cf 100644
--- a/src/mongo/db/matcher/matcher.cpp
+++ b/src/mongo/db/matcher/matcher.cpp
@@ -55,7 +55,9 @@ Matcher::Matcher(const BSONObj& pattern,
     _expression = std::move(statusWithMatcher.getValue());
 }
 
-bool Matcher::matches(const BSONObj& doc, MatchDetails* details) const {
+bool Matcher::matches(const BSONObj& doc,
+                      ArrayPositionalMatch* details,
+                      std::deque<std::string>* explain) const {
     if (!_expression)
         return true;
 
diff --git a/src/mongo/db/matcher/matcher.h b/src/mongo/db/matcher/matcher.h
index 1e4fbd999c..39f537e971 100644
--- a/src/mongo/db/matcher/matcher.h
+++ b/src/mongo/db/matcher/matcher.h
@@ -34,10 +34,10 @@
 #include "mongo/base/disallow_copying.h"
 #include "mongo/base/status.h"
 #include "mongo/bson/bsonobj.h"
+#include "mongo/db/matcher/array_positional_match.h"
 #include "mongo/db/matcher/expression.h"
 #include "mongo/db/matcher/expression_parser.h"
 #include "mongo/db/matcher/extensions_callback_noop.h"
-#include "mongo/db/matcher/match_details.h"
 
 
 namespace mongo {
@@ -60,7 +60,9 @@ public:
             MatchExpressionParser::AllowedFeatureSet allowedFeatures =
                 MatchExpressionParser::kDefaultSpecialFeatures);
 
-    bool matches(const BSONObj& doc, MatchDetails* details = NULL) const;
+    bool matches(const BSONObj& doc,
+                 ArrayPositionalMatch* details = nullptr,
+                 std::deque<std::string>* = nullptr) const;
 
     const BSONObj* getQuery() const {
         return &_pattern;
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_all_elem_match_from_index.h b/src/mongo/db/matcher/schema/expression_internal_schema_all_elem_match_from_index.h
index dfa64a171d..793a975f5c 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_all_elem_match_from_index.h
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_all_elem_match_from_index.h
@@ -47,15 +47,24 @@ public:
 
     std::unique_ptr<MatchExpression> shallowClone() const final;
 
-    bool matchesArray(const BSONObj& array, MatchDetails* details) const final {
+    bool matchesArray(const BSONObj& array,
+                      ArrayPositionalMatch* details,
+                      std::deque<std::string>* explain) const final {
         auto iter = BSONObjIterator(array);
-        for (int i = 0; iter.more() && i < _index; i++) {
+        int index = 0;
+        for (; iter.more() && index < _index; ++index) {
             iter.next();
         }
         while (iter.more()) {
             if (!_expression->matchesBSONElement(iter.next(), details)) {
+                if (explain) {
+                    explain->push_front(str::stream() << "element " << index << " of array '"
+                                                      << path()
+                                                      << "' does not satisfy subquery: ");
+                }
                 return false;
             }
+            ++index;
         }
         return true;
     }
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_allowed_properties.cpp b/src/mongo/db/matcher/schema/expression_internal_schema_allowed_properties.cpp
index 5fa61fd23e..645d983fb5 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_allowed_properties.cpp
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_allowed_properties.cpp
@@ -87,13 +87,15 @@ bool InternalSchemaAllowedPropertiesMatchExpression::equivalent(const MatchExpre
                             });
 }
 
-bool InternalSchemaAllowedPropertiesMatchExpression::matches(const MatchableDocument* doc,
-                                                             MatchDetails* details) const {
+bool InternalSchemaAllowedPropertiesMatchExpression::matches(
+    const MatchableDocument* doc,
+    ArrayPositionalMatch* details,
+    std::deque<std::string>* explain) const {
     return _matchesBSONObj(doc->toBSON());
 }
 
-bool InternalSchemaAllowedPropertiesMatchExpression::matchesSingleElement(const BSONElement& elem,
-                                                                          MatchDetails*) const {
+bool InternalSchemaAllowedPropertiesMatchExpression::matchesSingleElement(
+    const BSONElement& elem, ArrayPositionalMatch*, std::deque<std::string>* explain) const {
     if (elem.type() != BSONType::Object) {
         return false;
     }
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_allowed_properties.h b/src/mongo/db/matcher/schema/expression_internal_schema_allowed_properties.h
index 89c7448ec7..aa51128f10 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_allowed_properties.h
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_allowed_properties.h
@@ -131,8 +131,12 @@ public:
      *  - any field not contained in '_properties' nor matching a pattern in '_patternProperties'
      *    matches the '_otherwise' match expression.
      */
-    bool matches(const MatchableDocument* doc, MatchDetails* details) const final;
-    bool matchesSingleElement(const BSONElement& element, MatchDetails* details) const final;
+    bool matches(const MatchableDocument* doc,
+                 ArrayPositionalMatch* details,
+                 std::deque<std::string>* explain) const final;
+    bool matchesSingleElement(const BSONElement& element,
+                              ArrayPositionalMatch* details,
+                              std::deque<std::string>* explain) const final;
 
     void serialize(BSONObjBuilder* builder) const final;
 
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_cond.cpp b/src/mongo/db/matcher/schema/expression_internal_schema_cond.cpp
index b05de7d8d6..80d4cefaf7 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_cond.cpp
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_cond.cpp
@@ -34,13 +34,16 @@ namespace mongo {
 constexpr StringData InternalSchemaCondMatchExpression::kName;
 
 bool InternalSchemaCondMatchExpression::matches(const MatchableDocument* doc,
-                                                MatchDetails* details) const {
+                                                ArrayPositionalMatch* details,
+                                                std::deque<std::string>* explain) const {
     return condition()->matches(doc, details) ? thenBranch()->matches(doc, details)
                                               : elseBranch()->matches(doc, details);
 }
 
-bool InternalSchemaCondMatchExpression::matchesSingleElement(const BSONElement& elem,
-                                                             MatchDetails* details) const {
+bool InternalSchemaCondMatchExpression::matchesSingleElement(
+    const BSONElement& elem,
+    ArrayPositionalMatch* details,
+    std::deque<std::string>* explain) const {
     return condition()->matchesSingleElement(elem, details)
         ? thenBranch()->matchesSingleElement(elem, details)
         : elseBranch()->matchesSingleElement(elem, details);
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_cond.h b/src/mongo/db/matcher/schema/expression_internal_schema_cond.h
index ab5f38b4d0..ef45210d4b 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_cond.h
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_cond.h
@@ -69,8 +69,12 @@ public:
      * If the input object matches 'condition', returns the result of matching it against
      * 'thenBranch'. Otherwise, returns the result of matching it against 'elseBranch'.
      */
-    bool matches(const MatchableDocument* doc, MatchDetails* details = nullptr) const final;
-    bool matchesSingleElement(const BSONElement& elem, MatchDetails* details = nullptr) const final;
+    bool matches(const MatchableDocument* doc,
+                 ArrayPositionalMatch* details = nullptr,
+                 std::deque<std::string>* explain = nullptr) const final;
+    bool matchesSingleElement(const BSONElement& elem,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final;
 };
 
 }  // namespace mongo
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_eq.cpp b/src/mongo/db/matcher/schema/expression_internal_schema_eq.cpp
index b28de000a3..fb7581bb23 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_eq.cpp
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_eq.cpp
@@ -48,7 +48,8 @@ InternalSchemaEqMatchExpression::InternalSchemaEqMatchExpression(StringData path
 }
 
 bool InternalSchemaEqMatchExpression::matchesSingleElement(const BSONElement& elem,
-                                                           MatchDetails* details) const {
+                                                           ArrayPositionalMatch* details,
+                                                           std::deque<std::string>* explain) const {
     return _eltCmp.evaluate(_rhsElem == elem);
 }
 
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_eq.h b/src/mongo/db/matcher/schema/expression_internal_schema_eq.h
index 5afa686009..6469f3a300 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_eq.h
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_eq.h
@@ -49,7 +49,9 @@ public:
 
     std::unique_ptr<MatchExpression> shallowClone() const final;
 
-    bool matchesSingleElement(const BSONElement&, MatchDetails*) const final;
+    bool matchesSingleElement(const BSONElement&,
+                              ArrayPositionalMatch*,
+                              std::deque<std::string>* explain) const final;
 
     void debugString(StringBuilder& debug, int level) const final;
 
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_fmod.cpp b/src/mongo/db/matcher/schema/expression_internal_schema_fmod.cpp
index 3cc617d94b..b6bc2cef63 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_fmod.cpp
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_fmod.cpp
@@ -47,8 +47,8 @@ InternalSchemaFmodMatchExpression::InternalSchemaFmodMatchExpression(StringData
     uassert(ErrorCodes::BadValue, "divisor cannot be infinite", !divisor.isInfinite());
 }
 
-bool InternalSchemaFmodMatchExpression::matchesSingleElement(const BSONElement& e,
-                                                             MatchDetails* details) const {
+bool InternalSchemaFmodMatchExpression::matchesSingleElement(
+    const BSONElement& e, ArrayPositionalMatch* details, std::deque<std::string>* explain) const {
     if (!e.isNumber()) {
         return false;
     }
diff --git a/src/mongo/db/matcher/schema/expression_internal_schema_fmod.h b/src/mongo/db/matcher/schema/expression_internal_schema_fmod.h
index 6847913187..67a1bdf23d 100644
--- a/src/mongo/db/matcher/schema/expression_internal_schema_fmod.h
+++ b/src/mongo/db/matcher/schema/expression_internal_schema_fmod.h
@@ -49,7 +49,9 @@ public:
         return std::move(m);
     }
 
-    bool matchesSingleElement(const BSONElement& e, MatchDetails* details = nullptr) const final;
+    bool matchesSingleElement(const BSONElement& e,
+                              ArrayPositionalMatch* details = nullptr,
+                              std::deque<std::string>* explain = nullptr) const final;
 
     void debugString(StringBuilder& debug, int level) const final;
 
